/* This is a mite bit hackish way to handle suid programs. See below for more
   discussion. 
 */

void suid_hack(struct task_struct *p)
{
   struct sj_argv_memory *memory;

#ifdef PROFILE
   printk("(StJude) Enterd Suid Hack\n");
#endif
        /* It has some vestages of privlage, lets check
           if its in the hash. 
         */
                /* We do not have a priv record for this suid privlaged.
                   process. This will occur, but only should occur when
                   a suid process is run. The privlage bits in the task
                   structure is set deep inside exec() without a syscall
                   (ie, the exec() call modifies the task_struc). This poses
                   a problem for us, since we do not know that a process
                   has been given privlage. What we will do here is extract
                   the argv's for the command from its memory, and create
                   a privl record after getting the proper restriction index.
                 */


		  memory = get_argv_memory(p->pid);
                  if (memory) {
			    int r_index = 0;
                  
		/* Note, here we will need to get an index based on the parent. */

                           r_index =  get_restriction_index(p->p_pptr->pid,
						memory->argv);

                           create_priv_record(p->pid,r_index);
                    }
                    else  
                      create_priv_record(p->pid,0);
   			return;

}
                        			    
                        
/*
 * 
 * On a fork we will need to check if the process has privlage.
 * If yes, then does it have a privlage record?
 *
 *    If it has privlage and no privlage record, then we shall
 *    presume it is a setuid program. At this point we generate
 *    get the index for its restriction, and generate a privlage 
 *    record.
 *
 * If we do have a privlage record, then we need to generate a
 * generate a privlage record for our guy based on the parent's
 * informaiton. 
 *
 */
                       
int
sj_fork (struct pt_regs regs)
{
  int sj_fork_return;
  struct sj_argv_memory  * memory;  

#ifdef __SMP__
read_lock(&sj_running);
read_lock(&tasklist_lock);
#endif

#ifdef PROFILE
printk(" -----------------------------SYSCALL BY %d------------------------\n",current->pid);
#endif

#ifdef __SMP__
read_unlock(&tasklist_lock);
#endif

  sj_fork_return = (*orig_fork) (regs);
 
#ifdef __SMP__
read_lock(&tasklist_lock);
#endif

#ifdef __SMP__
read_lock(&argv_memory_lock);
#endif

memory = get_argv_memory(current->pid);
if (memory)
   {
          
         memory = create_argv_memory(sj_fork_return,memory->argv);
           if (!memory)
             printk("(StJude) sj_fork: Something bad happened, I can't remember argv's.\n");
   }
   else
    printk("(StJude) sj_fork: Can't Recall argv for %d.\n",current->pid);

#ifdef __SMP__
read_unlock(&argv_memory_lock);
write_lock(&priv_lock);
#endif

if (!(current->euid && current->uid && current->suid))
       { 
      struct sj_priv *child;
      struct sj_priv *parent;
      
      parent = get_priv_record(current->pid);
      if (!parent)
	{
#ifdef __SMP__
           write_lock(&argv_memory_lock);
#endif
           suid_hack(current);
#ifdef __SMP__
           write_unlock(&argv_memory_lock);
#endif

           parent = get_priv_record(current->pid);
	   if (!parent)
		{
		   printk("(StJude) sj_fork: Brace yourself, we are going to crash!\n");
                }
        }

   if (sj_fork_return > 0) {
   
          if (parent)
               child = create_priv_record(sj_fork_return,parent->restriction->r_index); 
           else
	       child = create_priv_record(sj_fork_return,0);

       }
  }

#ifdef __SMP__
write_unlock(&priv_lock);
read_unlock(&tasklist_lock);
read_unlock(&sj_running);
#endif


  return sj_fork_return;
}


/* See fork */

int
sj_vfork (struct pt_regs regs)
{
  int sj_vfork_return;

#ifdef __SMP__
read_lock(&sj_running);
read_lock(&tasklist_lock);
write_lock(&priv_lock);
#endif

#ifdef PROFILE
printk(" -----------------------------SYSCALL BY %d------------------------\n",current->pid);
#endif
#ifdef PROFILE
       printk("  (StJude) sj_vfork: Entered sj_vfork()\n");
#endif


if (!(current->euid && current->uid && current->suid))
       { 
      struct sj_priv *priv;
      
      priv = get_priv_record(current->pid);
      if (!priv)
	{
#ifdef __SMP__
           write_lock(&argv_memory_lock);
#endif
           suid_hack(current);
#ifdef __SMP__
           write_unlock(&argv_memory_lock);
#endif
        }
      }
#ifdef __SMP__
write_unlock(&priv_lock);
read_unlock(&tasklist_lock);
read_unlock(&sj_running);
#endif

  sj_vfork_return = (*orig_vfork) (regs);

  /* We have to implement vfork support as a hack. The reason is that the vfork call
     will not return UNTILL after an exit() or execeve() by the child process. This
     kinda doesn't work for us since we want to set up some memory stuffs and priv
     stuffs BEFORE it can exec(). Duh.

     See vfork_hack().

   */


  return sj_vfork_return;
}

/* See fork */
int
sj_clone (struct pt_regs regs)
{
  int sj_clone_return;
  struct sj_argv_memory *memory;

#ifdef __SMP__
read_lock(&sj_running);
read_lock(&tasklist_lock);
#endif

#ifdef PROFILE
printk(" -----------------------------SYSCALL BY %d------------------------\n",current->pid);
#endif
#ifdef PROFILE
       printk("  (StJude) sj_cline: Entered sj_clone()\n");
#endif

#ifdef __SMP__
read_unlock(&tasklist_lock);
#endif

  sj_clone_return = (*orig_clone) (regs);

#ifdef __SMP__
read_lock(&tasklist_lock);
write_lock(&argv_memory_lock); 
#endif

memory = get_argv_memory(current->pid);
if (!(memory && create_argv_memory(sj_clone_return,memory->argv)))
           printk("(StJude) sj_Clone: Something bad happened, I can't remember argv's.\n");

#ifdef __SMP__
write_unlock(&argv_memory_lock); 
#endif

if (!(current->euid && current->uid && current->suid))
       {  
      struct sj_priv *child;
      struct sj_priv *parent;

#ifdef __SMP__
write_lock(&priv_lock);
#endif
      parent = get_priv_record(current->pid);
      
      if (!parent) {
#ifdef __SMP__
            write_lock(&argv_memory_lock);
#endif
            suid_hack(current);  
#ifdef __SMP__
            write_unlock(&argv_memory_lock);
#endif

           parent = get_priv_record(current->pid);
	   if (!parent)
		{
		   printk("(StJude) sj_fork: Brace yourself, we are going to crash!\n");
                }
        }

/* The way we will handle forks is simple.. We create a priv thinggie
   but with the 0 as its index. Then we assign the value of the parent's 
   priv record to the child.
 */

   if (sj_clone_return > 0) {
  
           if (parent) 
                  child = create_priv_record(sj_clone_return,parent->restriction->r_index); 
            else
                  child = create_priv_record(sj_clone_return,0); 
    

    }

#ifdef __SMP__
write_unlock(&priv_lock);
#endif

 } 

#ifdef __SMP__
read_unlock(&tasklist_lock);
read_unlock(&sj_running);
#endif


  return sj_clone_return;
}

/* We are evil, we will not let any more modules be
   loaded. To play nice, we pretend we are out of
   ram. heh heh heh
 */

asmlinkage unsigned long
sj_create_module (const char *name, size_t size)
{
#ifdef PROFILE
#ifdef __SMP__
read_lock(&tasklist_lock);
#endif
printk(" -----------------------------SYSCALL BY %d------------------------\n",current->pid);
#ifdef __SMP__
read_unlock(&tasklist_lock);
#endif
#endif

#ifdef PROFILE
       printk("  (StJude) sj_create_module:  Entered sj_create_module()\n");
#endif
  return -ENOMEM;
}

/*
 * This is it, what we have been watiing for, the grand show.
 *
 * First, check if we are a privlaged process. If no, then let
 * them pass.
 *
 * If we are a privlaged process, then we need to make shure that
 * what we want to execute is ok. We do this by calling check_priv_record.
 * If it is ok, then we will let them pass, but we have to do some
 * record keeping first.
 * 
 *    We need to modify the current privlage record to reflect the new
 *    command we are executing. We do this by changing the restriction
 *    list associated with the current process. The quickest way to do
 *    this is modify_priv_record_restriction(pid,get_restriction_index(pid,argv)))
 *
 */

int
sj_do_execve (char *filename, char **argv, char **envp)
{
  long sj_res;
  struct sj_argv_memory *memory;
  int sj_i,sj_j,sj_argc;
  char sj_argv[MAX_KEY_ELEMENTS][BUFFSIZE];

#ifdef __SMP__
read_lock(&sj_running);
read_lock(&tasklist_lock);
#endif
#ifdef PROFILE
printk(" -----------------------------SYSCALL BY %d------------------------\n",current->pid);
#endif

#ifdef PROFILE
       printk("  (StJude) sj_execve: Entered sj_do_execve()\n");
#endif
 
   
  sj_argc = count(argv,MAX_KEY_ELEMENTS);
  sj_argc = (sj_argc == -E2BIG) ? MAX_KEY_ELEMENTS : sj_argc;
  
   for (sj_i = 0; sj_i < MAX_KEY_ELEMENTS; sj_i++)
	for (sj_j = 0; sj_j < BUFFSIZE; sj_j++)
	      sj_argv[sj_i][sj_j] = '\0';

   for (sj_i = 0; sj_i < BUFFSIZE && filename[sj_i] != '\0';
           sj_i++)
            sj_argv[0][sj_i] = filename[sj_i];
 
   sj_argv[0][sj_i] = '\0';

   
   for (sj_i = 1; sj_i < sj_argc; sj_i++)
     {
        for (sj_j = 0; sj_j < BUFFSIZE && argv[sj_i][sj_j] != '\0';
             sj_j++)
          {
              sj_argv[sj_i][sj_j] = argv[sj_i][sj_j];
          } 
          sj_argv[sj_i][sj_j] = '\0';
     } 

#ifdef __SMP__
write_lock(&priv_lock); 
write_lock(&argv_memory_lock); 
#endif

   memory = get_argv_memory(current->pid);

 
   if (!(current->uid && current->euid && current->suid) )
   {
      struct sj_priv *priv;

      priv = get_priv_record(current->pid);
    
      if (!priv) {
      suid_hack(current);
      } 

     

    if (!check_priv_record(current->pid,sj_argv))
       {
          char argv_string[BUFFSIZE * MAX_KEY_ELEMENTS];
          char parent_string[BUFFSIZE * MAX_KEY_ELEMENTS];
          struct sj_argv_memory *p_memory;

          int i,j,k;
       
          for (i = 0; i < BUFFSIZE * MAX_KEY_ELEMENTS; i++)
		{ argv_string[i] = '\0'; parent_string[i] = '\0'; }


          k = 0; 
          for (i = 0; i < MAX_KEY_ELEMENTS; i++)
          {
              for (j = 0; j < BUFFSIZE && sj_argv[i][j] != '\0'; j++)
                 {
                    argv_string[k++] = sj_argv[i][j];
                    if (k >= ( BUFFSIZE * MAX_KEY_ELEMENTS)-2)
			       break;
                 }
                     
                    if (k >= ( BUFFSIZE * MAX_KEY_ELEMENTS)-2)
			       break;
                    argv_string[k++] = ' ';
           }
           argv_string[k] = '\0';
    
           p_memory = get_argv_memory(current->p_pptr->pid);
           if (p_memory)
           {

          k = 0; 
          for (i = 0; i < MAX_KEY_ELEMENTS; i++)
          {
              for (j = 0; j < BUFFSIZE && p_memory->argv[i][j] != '\0'; j++)
                 {
                    parent_string[k++] = p_memory->argv[i][j];
                    if (k >= ( BUFFSIZE * MAX_KEY_ELEMENTS)-2)
			       break;
                 }
                     
                    if (k >= ( BUFFSIZE * MAX_KEY_ELEMENTS)-2)
			       break;
                    parent_string[k++] = ' ';
           }
           argv_string[k] = '\0';

           }
           
		/* Apparently we dont't have permission to do 
                   what we are wanting to do. First we bitch,
                   then we gripe. */
printk("(STJUDE) NOTICE: Execution Request Violates Privlages. Data Follows.\n");
printk("(STJUDE) NOTICE: UID: %d, EUID %d, Command Line: %s\n",current->uid, current->euid, argv_string);
if (p_memory)
    printk("(STJUDE) NOTICE: Parent Process was PID %d. Argv: %s\n",current->p_pptr->pid, parent_string);

#ifndef LEARNING
#ifdef __SMP__
         write_unlock(&argv_memory_lock);
         write_unlock(&priv_lock);
         read_unlock(&tasklist_lock);
         read_unlock(&sj_running);
#endif
	 return 0;
#endif

           
       }
       else
       {
/* If it wasn't illegal, and we are still privlaged, then we need to update
   our privlage record to the restrictions for our new process. We will do
   this by figuring out the index to our new restriction, destroying our privlage
   record and then creating a new privlage record based on the index we have.
 */

	    int r_index = 0;
            
            r_index =  get_restriction_index(current->pid, memory->argv);
            destroy_priv_record(current->pid); 
            create_priv_record(current->pid,r_index);

       }


		 

   } /* Of privlaged Code */



    if (memory) 
       {
          int i,j;
          
          for (i = 0; i < MAX_KEY_ELEMENTS; i++)
		{
            for (j = 0; j < BUFFSIZE; j++)
	         {
		    memory->argv[i][j] = sj_argv[i][j]; }
                 }
		 memory->argv[i][BUFFSIZE-1] = '\0';
       }

#ifdef __SMP__
write_unlock(&argv_memory_lock);
write_unlock(&priv_lock);
read_unlock(&tasklist_lock);
read_unlock(&sj_running);
#endif

  __asm__ volatile ("int $0x80":"=a" (sj_res):"0" (sjexecve), "b" ((long) (filename)),
		    "c" ((long) (argv)), "d" ((long) (envp)));

  /* We should never get here */

  return (int) sj_res;
}

/* We are busy! Go away! */
int
sj_delete_module (const char *name)
{
#ifdef __SMP__
read_lock(&tasklist_lock);
#endif

#ifdef PROFILE
printk(" -----------------------------SYSCALL BY %d------------------------\n",current->pid);
#endif

#ifdef __SMP__
read_unlock(&tasklist_lock);
#endif

  return -EBUSY;
}

/* When a process exists, we shall delete the
   privlage entry. We need to know nothing about
   the process when it will no longer spawn
   processes. 
 */

int
sj_exit (int error)   /* DONE */
{
  int sj_exit_ret;
#ifdef __SMP__
read_lock(&sj_running);
read_lock(&tasklist_lock);
#endif

#ifdef PROFILE
printk(" -----------------------------SYSCALL BY %d------------------------\n",current->pid);
#endif

#ifdef PROFILE
  printk ("(StJude) sj_exit: Pid %d Exit.\n", current->pid);
#endif

#ifdef __SMP__
write_lock(&argv_memory_lock);
#endif
  destroy_argv_memory(current->pid);
#ifdef __SMP__
write_unlock(&argv_memory_lock);
#endif

  if (!(current->uid && current->euid && current->suid))
  {
        /* Its ok if we delete a record that doesn't exist here..
           If a suid program spawned and exit() was its first
           syscall it could happen. Thats all good. 
         */
#ifdef __SMP__
    write_lock(&priv_lock);
#endif
        destroy_priv_record(current->pid);
           
        
#ifdef __SMP__
    write_unlock(&priv_lock);
#endif
  }

#ifdef __SMP__
read_unlock(&tasklist_lock);
read_unlock(&sj_running);
#endif

  sj_exit_ret = (*orig_exit) (error);
  return sj_exit_ret;
}


/*
 * If we set the uid of the process to both non-root
 * ids then we can not transition back into root.
 * At this point we can then remove the privlage
 * entry from the stuff. 
 */

int
sj_setreuid (uid_t ruid, uid_t euid)
{
  int sj_setreuid_return;
  short privlaged = 0;

#ifdef __SMP__
read_lock(&sj_running);
read_lock(&tasklist_lock);
#endif

#ifdef PROFILE
printk(" -----------------------------SYSCALL BY %d------------------------\n",current->pid);
#endif

#ifdef PROFILE
printk("(StJude) sj_setreuid: Entered setreuid()\n");
#endif
   
  if ( ! ( current->uid && current->euid && current->suid ) )
    { 
       struct sj_priv *priv;  

       privlaged = 1;

#ifdef __SMP__
       write_lock(&priv_lock);
#endif

        priv = get_priv_record(current->pid);
  
        if(!priv) {
#ifdef __SMP__
           write_lock(&argv_memory_lock);
#endif
           suid_hack(current);  
#ifdef __SMP__
           write_unlock(&argv_memory_lock);
#endif
           }

#ifdef __SMP__
        write_unlock(&priv_lock);
#endif
    }
#ifdef __SMP__
read_unlock(&tasklist_lock);
#endif

  sj_setreuid_return = (*orig_setreuid) (ruid,euid);

#ifdef __SMP__
read_lock(&tasklist_lock);
#endif


  /* If it was privlaged, but is not any more, then we should drip its record */

  if (privlaged && ( current->uid && current->euid && current->suid ) )
    {

#ifdef __SMP__
        write_lock(&priv_lock);
#endif
         destroy_priv_record(current->pid);
#ifdef __SMP__
        write_unlock(&priv_lock);
#endif


    }

#ifdef __SMP__
read_unlock(&tasklist_lock);
read_unlock(&sj_running);
#endif

  return sj_setreuid_return;
}

/*
 * If we set the uid of the process to both non-root
 * ids then we can not transition back into root.
 * At this point we can then remove the privlage
 * entry from the stuff. 
 */

int
sj_setuid (uid_t uid)
{
  int sj_setuid_return;
  short privlaged = 0;

#ifdef __SMP__
read_lock(&sj_running);
read_lock(&tasklist_lock);
#endif

#ifdef PROFILE
printk(" -----------------------------SYSCALL BY %d------------------------\n",current->pid);
#endif

#ifdef PROFILE
printk("(StJude) setuid: Entered setuid()\n");
#endif

  if ( ! ( current->uid && current->euid && current->suid ))
   {
       struct sj_priv *priv;  

       privlaged = 1;
#ifdef __SMP__
       write_lock(&priv_lock);
#endif

        priv = get_priv_record(current->pid);
  
        if(!priv)  {
#ifdef __SMP__
           write_lock(&argv_memory_lock);
#endif
           suid_hack(current);  
#ifdef __SMP__
           write_unlock(&argv_memory_lock);
#endif
           }

#ifdef __SMP__
       write_unlock(&priv_lock);
#endif
   }

#ifdef __SMP__
read_unlock(&tasklist_lock);
#endif

  sj_setuid_return = (*orig_setuid) (uid);

#ifdef __SMP__
read_lock(&tasklist_lock);
#endif

  /* If it was privlaged, but is not any more, then we should drip its record */

  if (privlaged && ( current->uid && current->euid && current->suid ))
   {
#ifdef __SMP__
       write_lock(&priv_lock);
#endif
      destroy_priv_record(current->pid);
#ifdef __SMP__
       write_unlock(&priv_lock);
#endif
   }

#ifdef __SMP__
read_unlock(&tasklist_lock);
#endif
read_unlock(&sj_running);

  return sj_setuid_return;

}

